/*-
 * Copyright (c) 2005 Stanislav Sedov <ssedov@mbsd.msk.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: fuser.h,v 1.5 2005/08/25 01:43:42 stas Exp $
 */

#ifndef	__FUSER_H__
#define	__FUSER_H__

/* Global typedefs */
typedef struct vnode vnode_t;
typedef struct kinfo_proc kinfo_proc_t;

/* Global KVM desctiptor */
extern kvm_t	*kd;

typedef struct finfo{  
	ino_t			ino;	/* Inode number */
	dev_t			dev;	/* Device the file located on */   
	int			uflags; /* How this file is used */
	SLIST_ENTRY(finfo)	next;
} finfo_t;

#define KVM_READ(kd, addr, buf, buflen)	\
    kvm_read(kd, (unsigned long)addr, buf, buflen)

#undef FUDEBUG
#if defined(FUDEBUG)
# define ASSERT(x) assert(x)
# else
# define ASSERT(x)
#endif

/* Prototypes */
dev_t	dev2udev		__P((const struct cdev *dev));
int	isofs_filestat		__P((const vnode_t *vp, finfo_t *fsp));
int	msdosfs_filestat	__P((const vnode_t *vp, finfo_t *fsp));
int	ufs_filestat		__P((const vnode_t *vp, finfo_t *fsp));
int	devfs_filestat		__P((const vnode_t *vp, finfo_t *fsp));
int	nfs_filestat		__P((const vnode_t *vp, finfo_t *fsp));
int	ntfs_filestat		__P((const vnode_t *vp, finfo_t *fsp));
int	nwfs_filestat		__P((const vnode_t *vp, finfo_t *fsp));
int	smbfs_filestat		__P((const vnode_t *vp, finfo_t *fsp));
int	udf_filestat		__P((const vnode_t *vp, finfo_t *fsp));

#endif /* __FUSER_H__ */
